@echo off
setlocal enabledelayedexpansion
rem Always you must be carefull for spaces and special characters in path name

call :update_CppPropertiesFile "%~dp0\..\.."
goto :EOF

:update_CppPropertiesFile

call "%~dp0inherit_environments.bat" -GetCppPropertiesFileName
set BACKUPFOLDER=%DATE:/=-%-%TIME::=-%
set BACKUPFOLDER=%BACKUPFOLDER: =0%
set BACKUPFOLDER=%BACKUPFOLDER:~0,-3%
set ORGFILE=%~dpn1\%CppPropertiesFileName%
set BAKFILE=%~dpn1\trash\%BACKUPFOLDER%\%CppPropertiesFileName%

:backup
if not exist "%ORGFILE%" goto :error_file_not_found
echo '%CppPropertiesFileName%' is found.
echo Backup the file to trash folder.
mkdir "%BAKFILE%\..\" 1>nul
if errorlevel 1 goto :error_backup
move "%ORGFILE%" "%BAKFILE%\..\" 1>nul
if errorlevel 1 goto :error_backup
echo Update the file for this e2 studio project.

:update
set is_env_flag=false
for /f "usebackq tokens=1 delims=" %%L in ("%BAKFILE%") do (
    set LINE=%%L
    for /f "usebackq tokens=1* delims=:" %%I in ('%%L') do (
        set STR0=%%I
    )
    rem Do not remove `tab` in delims.
    for /f "usebackq tokens=1* delims=:	 " %%I in ('%%L') do (
        set STR1=%%~I
        set STR2=
        if "!STR1!" == "env" (
            set is_env_flag=true
        ) else if "!STR1:~0,2!" == "}," (
            set is_env_flag=false
        ) else if "!STR1:~0,2!" == "}" (
            set is_env_flag=false
        ) else if "!STR1:~0,2!" == "//" (
            rem Nothing to do
        ) else if "!STR1!" == "PROJECT_NAME" (
            set STR2=%PROJECT_NAME%
        ) else if "!STR1!" == "E2STUDIO_WORKSPACE_FOLDER" (
            set STR2=%E2STUDIO_WORKSPACE_FOLDER%
        ) else if "!STR1!" == "ECLIPSE_HOME" (
            set STR2=%ECLIPSE_HOME%
        ) else if "!STR1!" == "SUPPORT_AREA" (
            set STR2=%SUPPORT_AREA%
        ) else if "!STR1!" == "PYTHONHOME" (
            set STR2=%PYTHONHOME%
        ) else if "!STR1!" == "TCINSTALL" (
            set STR2=%TCINSTALL%
        )
    )
    if not "!STR2!" == "" (
        set STR2=!STR2:\=\\!
        if "!STR2:~-2!" == "\\" (
            set STR2=!STR2:~0,-2!
        )
        set LINE=!STR0!: "!STR2!",
    )
    echo !LINE!>>"%ORGFILE%"
)

:completed
echo Completed.

:clean_up
set is_env_flag=
set STR0=
set STR1=
set LINE=
goto :EOF

:error_file_not_found
echo Error: '%CppPropertiesFileName%' is not found.
exit 256

:error_backup
echo Error: Unable to backup the file.
exit %ERRORLEVEL%
